ClassNodeResolver (Groovy 2.4.15)
Date: 2018-03-23

org.codehaus.groovy.control

## Class ClassNodeResolver

- java.lang.Object
- - org.codehaus.groovy.control.ClassNodeResolver

-     public class ClassNodeResolver
      extends java.lang.Object

  This class is used as a pluggable way to resolve class names. An instance of this class has to be added to `CompilationUnit` using `CompilationUnit.setClassNodeResolver(ClassNodeResolver)`. The CompilationUnit will then set the resolver on the `ResolveVisitor` each time new. The ResolveVisitor will prepare name lookup and then finally ask the resolver if the class exists. This resolver then can return either a SourceUnit or a ClassNode. In case of a SourceUnit the compiler is notified that a new source is to be added to the compilation queue. In case of a ClassNode no further action than the resolving is done. The lookup result is stored in the helper class `ClassNodeResolver.LookupResult`. This class provides a class cache to cache lookups. If you don't want this, you have to override the methods `cacheClass(String, ClassNode)` and `getFromClassCache(String)`. Custom lookup logic is supposed to go into the method `findClassNode(String, CompilationUnit)` while the entry method is `resolveName(String, CompilationUnit)`
  Author:
    Jochen "blackdrag" Theodorou

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ClassNodeResolver.LookupResult` Helper class to return either a SourceUnit or ClassNode.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static ClassNode` | `NO_CLASS` Internal helper used to indicate a cache hit for a class that does not exist.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ClassNodeResolver()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cacheClass(java.lang.String name, ClassNode res)` caches a ClassNode
    `ClassNodeResolver.LookupResult` | `findClassNode(java.lang.String name, CompilationUnit compilationUnit)` Extension point for custom lookup logic of finding ClassNodes.
    `ClassNode` | `getFromClassCache(java.lang.String name)` returns whatever is stored in the class cache for the given name
    `ClassNodeResolver.LookupResult` | `resolveName(java.lang.String name, CompilationUnit compilationUnit)` Resolves the name of a class to a SourceUnit or ClassNode.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NO_CLASS

          protected static final ClassNode NO_CLASS

      Internal helper used to indicate a cache hit for a class that does not exist. This way further lookups through a slow `findClassNode(String, CompilationUnit)` path can be avoided. WARNING: This class is not to be used outside of ClassNodeResolver.

  - ### Constructor Detail

    - #### ClassNodeResolver

          public ClassNodeResolver()

  - ### Method Detail

    - #### resolveName

          public ClassNodeResolver.LookupResult resolveName(java.lang.String name,
                                                            CompilationUnit compilationUnit)

      Resolves the name of a class to a SourceUnit or ClassNode. If no class or source is found this method returns null. A lookup is done by first asking the cache if there is an entry for the class already available to then call `findClassNode(String, CompilationUnit)`. The result of that method call will be cached if a ClassNode is found. If a SourceUnit is found, this method will not be asked later on again for that class, because ResolveVisitor will first ask the CompilationUnit for classes in the compilation queue and it will find the class for that SourceUnit there then. method return a ClassNode instead of a SourceUnit, the res
      Parameters:
        `name` - - the name of the class
        `compilationUnit` - - the current CompilationUnit
      Returns:
        the LookupResult

    - #### cacheClass

          public void cacheClass(java.lang.String name,
                                 ClassNode res)

      caches a ClassNode
      Parameters:
        `name` - - the name of the class
        `res` - - the ClassNode for that name

    - #### getFromClassCache

          public ClassNode getFromClassCache(java.lang.String name)

      returns whatever is stored in the class cache for the given name
      Parameters:
        `name` - - the name of the class
      Returns:
        the result of the lookup, which may be null

    - #### findClassNode

          public ClassNodeResolver.LookupResult findClassNode(java.lang.String name,
                                                              CompilationUnit compilationUnit)

      Extension point for custom lookup logic of finding ClassNodes. Per default this will use the CompilationUnit class loader to do a lookup on the class path and load the needed class using that loader. Or if a script is found and that script is seen as "newer", the script will be used instead of the class.
      Parameters:
        `name` - - the name of the class
        `compilationUnit` - - the current compilation unit
      Returns:
        the lookup result